#include <stdio.h>

#define N 9

#define INT_MAX 10000

int GRAPH[N][N] = {{}};;

void initGraph() {


	// Graph 1
	GRAPH[1][2] = 2;
	GRAPH[1][3] = 6;
	GRAPH[1][4] = 5;
	GRAPH[2][5] = 8;
	GRAPH[3][5] = 3;
	GRAPH[3][6] = 2;
	GRAPH[3][4] = 2;
	GRAPH[4][7] = 2;
	GRAPH[5][6] = 4;
	GRAPH[5][8] = 5;
	GRAPH[6][8] = 1;
	GRAPH[7][8] = 1;

/*	// Graph 2
	GRAPH[0][1] = 10;
	GRAPH[1][2] = 5;
	GRAPH[2][3] = 3;
	GRAPH[3][4] = 5;
	GRAPH[4][6] = 4;
	GRAPH[4][5] = 3;
	GRAPH[5][6] = 4;
	GRAPH[6][7] = 7;
	GRAPH[6][8] = 4;*/


/*  // Graph 3
	GRAPH[5][1] = 1;
	GRAPH[5][6] = 1;
	GRAPH[4][1] = 1;
	GRAPH[2][6] = 1;
	GRAPH[2][3] = 1;
	GRAPH[1][7] = 1;
	GRAPH[1][8] = 1;
	GRAPH[1][3] = 1;*/
}


void plotGraph() {
	int i,j;
	printf("  |");
	for (i=0; i<N; i++) {
			printf("%d\t", i);
	}
	printf("\n");
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
	printf("\n");

	for (i=0; i<N; i++) {
		printf("%d |", i);
		for (j=0; j<N; j++) {
			printf("%d\t", GRAPH[i][j]);
		}
		printf("\n");
	}
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");

}

void countIndegree(int I[N]) {
	int i,j;

	for (i=0; i<N; i++) {
		for (j=0; j<N; j++)  {
			if (GRAPH[i][j] != 0)
				I[j]++;
		}
	}

	printf("\n");
	for (i=0; i<N; i++)
		printf("%d=%d,\t", i, I[i]);

}

void topologicalSort(int I[N]) {

	int i, j, k;

	countIndegree(I);
	printf("\nTopological Sort:\n");

	for (i=0; i < N; i++){

		// find node with an indegree of "0"
		for (j=0; j < N; j++) {
			if (I[j] == 0) {
				I[j] = -1;
				break;
			}
		}

		printf("Next Process: %d\n", j);

		// decrease the indegree of i's neighbors
		for (k=0; k < N; k++)	{
			if (GRAPH[j][k] != 0) {
				I[k]--;
			}
		}
	}
	printf("\n");

}


int earliestEventTime(int vertex) {

	int i;
	int max=0, val;
	for (i=0; i<N; i++) {
		if (GRAPH[i][vertex] != 0) {
			// filter out the max
			val = earliestEventTime(i) + GRAPH[i][vertex];
			if (val>max)
				max = val;
		}
	}

	return max;

}


int latestEventTime(int vertex) {

	int j;
	int min = INT_MAX; // int_max
	int val;

	for (j=0; j<N; j++) {
		if (GRAPH[vertex][j] != 0) {
			val = latestEventTime(j) - GRAPH[vertex][j];
			if (val<min)
				min = val;
		}
	}

	if (min == INT_MAX)
		return earliestEventTime(vertex);

	return min;

}

int latestActivityTime(int i, int j) {
	return latestEventTime(j) - GRAPH[i][j];
}

int earliestActivityTime(int i, int j) {
	return earliestEventTime(i);
}

int main(int argc, char *argv[]) {

	// In-degree table for toposort
	int I[N] = {};

	int point;
	int i, j, slack;

	if (argc < 2) {
		printf("Wrong Input - Please use %s [0..%d]\n\n", argv[0], N);
		exit(-1);
	}
	point = atoi(argv[1]);
	if (point>=N){
		printf("Invalid Milestone %d!\n", point);
		exit(-1);
	}

	initGraph();
	plotGraph();

	topologicalSort(I);


	printf("Earliest Time (to reach milestone %d) = %d\n\n", point, earliestEventTime(point));
	printf("Latest Time (by which milestone %d has to occur, else project delayed)= %d\n", point, latestEventTime(point));

	for (i=0; i<N; i++) {
		for (j=0; j<N; j++) {
			if (GRAPH[i][j] != 0) {

				slack = latestActivityTime(i,j) - earliestActivityTime(i,j);
				//printf("%d\n" , slack);
				if (slack == 0)
				{
					printf("Activity (%d,%d) is on the critical path\n", i, j);
				}
			}
		}
	}

}

